#include <iostream>
#include <omp.h>


using namespace std;

int main(){
	int m=100, a[m], summ=0;
	short szalak=4;
	int sum[szalak];
	for(short i=0; i<szalak; i++) sum[i]=0;

	// Számok 0-tól 100-ig tömbben
	for(int i=0; i<m; i++){
		a[i]=i+1;
	}


	// Nem párhuzamosan kiszámolva a tömbelemek összegét:
	for(int i=0; i<m; i++){
		summ+=a[i];
	}
	cout<<"Osszeg egyszeru szamolassal: "<<summ<<endl;
	summ=0;


	// Párhuzamosan kiszámolva a tömbelemek összegét:
	#pragma omp parallel shared(summ,m,szalak) private(i) num_threads(szalak)
	{
		int threadId=omp_get_thread_num();	// ne kérje ki többször a szálazonosítót
		for(int i=0; i<(m/szalak); i++)		
			sum[threadId] += a[ (m/szalak)*threadId + i ];
	}

	for(short i=0; i<szalak; i++) summ+=sum[i];
	cout<<"Osszeg parhuzamositott szamolassal: "<<summ<<endl;
	summ=0;


	// Párhuzamosan kiszámolva a tömbelemek összegét (másik mód):
	#pragma omp parallel shared(sum,m,szalak) private(i) num_threads(szalak)
	{
		int threadId=omp_get_thread_num();	// ne kérje ki többször a szálazonosítót
		for(int i=threadId; i<m; i+=szalak)		
			summ += a[i];
	}
	cout<<"Osszeg parhuzamositott masik szamolassal: "<<summ<<endl;


	return 0;
}
