#include <iostream>
#include <cstdlib>
#include <ctime>
#include <math.h>
#include <omp.h>

using namespace std;

int main(){
	const int hanyszor=100000, thr=4;
	int i=hanyszor, darabresz[thr], darab=0;
	float j[thr],k[thr];
	for(int a=0; a<thr; ++a) { j[a]=0; k[a]=0; darabresz[a]=0; }
	srand((unsigned)(time(0)));
	
// reduction: művelet és változó megadása után a változó private lesz, mindenki külön használja
	#pragma omp parallel reduction(+,darab) num_threads(thr) 
	{
		int threadId=omp_get_thread_num();
		for(; i>0; --i){
			j[threadId] = (rand()%100+1) / 100.0;
			k[threadId] = (rand()%100+1) / 100.0;
			if((j[threadId]*j[threadId] +
			k[threadId]*k[threadId])<1) ++darabresz[thr];
		}
		#pragma omp critical(osszegzes)
		{darab+=darabresz[threadId];}
	}

	
	cout.precision(16);
	cout<<darab*4/(double)hanyszor*thr; // így jönne ki pi

	cout<<endl<<endl;
	
	return 0;

	// HF{jövő hét kedd dél}: Google/Wikipedia/bárhonnan a mátrix-vektor szorzás, ezt párhuzamosítani openmp-ben
}
