#include <iostream>
#include <cstdlib>
#include <ctime>
#include <omp.h>

using namespace std;

int main(){
	const int dimSzam=3;
	int matr[dimSzam][dimSzam], vekt[dimSzam], eredmenymatr[dimSzam];
	int i,j;
	
	srand((unsigned)(time(NULL)));
	
	// véletlen számokkal feltöltés (egyszerűség kedvéért egyjegyű számok)
	for(i=0; i<dimSzam; ++i) {
		vekt[i] = rand()%10;
		eredmenymatr[i] = 0;
		for(j=0; j<dimSzam; ++j)
			matr[i][j] = rand()%10;
	}

	// kiíratás az áttekinthetőség kedvéért
	for(i=0; i<dimSzam; ++i) {
		for(j=0; j<dimSzam; ++j)
			cout<<'['<<matr[i][j]<<"] ";
		cout<<"    ["<<vekt[i]<<"]     ["<<eredmenymatr[i]<<']'<<endl;
	}
	
	/*
	int k[dimSzam];
	#pragma omp parallel num_threads(dimSzam)
	{
		int threadId=omp_get_thread_num();
		for(k[threadId]=0; k[threadId]<dimSzam; ++k[threadId])
			eredmenymatr[threadId] += matr[threadId][k[threadId]] * vekt[k[threadId]];
	}
	*/
	
	#pragma omp parallel private(i) num_threads(dimSzam)
	{
		int threadId=omp_get_thread_num();
		for(i=0; i<dimSzam; ++i)
			eredmenymatr[threadId] += matr[threadId][i] * vekt[i];
	}
	
	// kiíratás még egyszer, eredménnyel
	cout<<endl<<"Eredmény:"<<endl;
	for(i=0; i<dimSzam; ++i) {
		for(j=0; j<dimSzam; ++j)
			cout<<'['<<matr[i][j]<<"] ";
		cout<<"    ["<<vekt[i]<<"]     ["<<eredmenymatr[i]<<']'<<endl;
	}
	return 0;
}
