#include <iostream>
#include <cstdlib>
#include <ctime>
#include <omp.h>

using namespace std;

int szalak;
int elemsz;
double *tomb;
double *temptomb;

int main(){
	cout.precision(6);
	cout << endl << endl << "Kerem a szalak szamat: ";
	cin >> szalak;
	cout << endl << endl << "Kerem az elemszamot: ";
	cin >> elemsz;
		if( elemsz==0 || elemsz==1) { cout << elemsz << " elemen nincs mit rendezni!" << endl; exit(0); }
	
	// Új elemszám(elemszam_k) kiszámolása -> a megadott elemszámnál nagyobb, minimális 2-hatvány
	int elemszam = 1;
	while(elemszam < elemsz) elemszam <<= 1;
	
	tomb = new double[elemszam];
	
	// Tömb feltöltése véletlen elemekkel a megadott elemszámig
	srand( (unsigned)(time(0)) );
	for(int i=0; i<elemsz; ++i){
		tomb[i] = (double)rand() / rand();
		cout << i << ".:" << tomb[i] << '\n';
	}
	
	// Tömb bővítése 2-hatvány elemszámúra negatív elemekkel (-1)
	for(int i=elemsz; i<elemszam; ++i)
		tomb[i] = -1;
	
	// Először a 2 hosszú sorok rendezése if-ekkel
	double temp;
	for(int a=0; a < elemszam>>1; ++a){
		if(tomb[2*a] > tomb[2*a+1]) {
			temp = tomb[2*a];
			tomb[2*a] = tomb[2*a+1];
			tomb[2*a+1] = temp;
		}
	}
	
	if(elemsz != 2){		// Két elemre nem szükséges további rendezés.
		// Összefésülő rendezés for ciklusokkal
		//   (Mindig egy ideiglenes tömbbe fésül össze, amit a ciklus végén visszaír az eredetibe. A sorhosszúság mindig duplázódik,
		//   a méretváltozó négyzetre emelésével (a hossz mindig egy 2-hatvány). )
		temptomb = new double[elemszam];
		int bal, jobb, egesz, i, j;
	
		for(int interv=2; interv!=elemszam; interv<<=1){
			//!int ciklusok = elemszam/szalak;
			#pragma omp parallel private(i,j,bal,jobb,egesz) num_threads(szalak)
			{
				int threadId = omp_get_thread_num();
				for(i=0; i<elemszam/(szalak*interv*2); ++i){
					j = interv*2*szalak*i;
					bal = jobb = egesz = 0;
					
					// Összefésülő rendezés
					while(bal<interv && jobb<interv){
						if(tomb[ j+ (threadId*interv*2) + bal] < tomb[ j+ (threadId*interv*2) + interv + jobb]){
							temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + bal];
							++bal;
						} else{
							temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + interv + jobb];
							++jobb;
						}
						++egesz;
					}
			
					while(bal<interv){
						temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + bal];
						++bal;
						++egesz;
					}
			
					while(jobb<interv){
						temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + interv + jobb];
						++jobb;
						++egesz;
					}
				}
				
				if(  ( (i*szalak*interv*2) + threadId*2*interv ) < elemszam  ){
					j = interv*2*szalak*i;
					bal = jobb = egesz = 0;
					
					// Összefésülő rendezés
					while(bal<interv && jobb<interv){
						if(tomb[ j+ (threadId*interv*2) + bal] < tomb[ j+ (threadId*interv*2) + interv + jobb]){
							temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + bal];
							++bal;
						} else{
							temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + interv + jobb];
							++jobb;
						}
						++egesz;
					}
			
					while(bal<interv){
						temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + bal];
						++bal;
						++egesz;
					}
			
					while(jobb<interv){
						temptomb[ j+ (threadId*interv*2) + egesz] = tomb[ j+ (threadId*interv*2) + interv + jobb];
						++jobb;
						++egesz;
					}
				}
			}
		
			// Ideiglenes tömb visszaírása
			for(int i=0; i<elemszam; ++i)	tomb[i] = temptomb[i];
		}
	}
	
	// A rendezett tömb kiírása (a negatív elemeket nem írja ki)
	cout << endl << endl << "Rendezve:" << endl << endl;
	for(int i=elemszam-elemsz; i<elemszam; ++i)
		cout << i-(elemszam-elemsz) << ".:" << tomb[i] << '\n';
	cout << endl << endl;
	return 0;
}
