#include <iostream>
#include <cstdlib>
#include <ctime>
#include <omp.h>

using namespace std;

int main(){
	cout.precision(6);
	
	int elemsz;
	cout << endl << endl << "Kerem az elemszamot: ";
	cin >> elemsz;
		if( elemsz==0 || elemsz==1) { cout << elemsz << " elemen nincs mit rendezni!" << endl; exit(0); }
	
	// Új elemszám(elemszam_k) kiszámolása -> a megadott elemszámnál nagyobb, minimális 2-hatvány
	int elemszam = 1;
	while(elemszam < elemsz) elemszam <<= 1;
	
	double tomb[elemszam];
	
	// Tömb feltöltése véletlen elemekkel a megadott elemszámig
	srand( (unsigned)(time(0)) );
	for(int i=0; i<elemsz; ++i){
		tomb[i] = (double)rand() / rand();
		cout << i << ".:" << tomb[i] << '\n';
	}
	
	// Tömb bővítése 2-hatvány elemszámúra negatív elemekkel (-1)
	for(int i=elemsz; i<elemszam; ++i)
		tomb[i] = -1;
	
	// Először a 2 hosszú sorok rendezése if-ekkel
	double temp;
	for(int a=0; a < elemszam>>1; ++a){
		if(tomb[2*a] > tomb[2*a+1]) {
			temp = tomb[2*a];
			tomb[2*a] = tomb[2*a+1];
			tomb[2*a+1] = temp;
		}
	}
	
	if(elemsz != 2){		// Két elemre nem szükséges további rendezés.
		// Összefésülő rendezés for ciklusokkal
		//   (Mindig egy ideiglenes tömbbe fésül össze, amit a ciklus végén visszaír az eredetibe. A sorhosszúság mindig duplázódik,
		//   a méretváltozó négyzetre emelésével (a hossz mindig egy 2-hatvány). )
		double temptomb[elemszam];
		int bal, jobb, egesz;
	
		for(int interv=2; interv!=elemszam; interv<<=1){												// két 2-hosszúságú sorral indít
			#pragma omp parallel private(bal,jobb,egesz) num_threads(elemszam/(2*interv))				// két sorra egy szál, párhuzamosítva
			{
				int threadId = omp_get_thread_num();
				bal = jobb = egesz = 0;
				
				// Összefésülő rendezés
				while(bal<interv && jobb<interv){
					if(tomb[ (threadId*interv*2) + bal] < tomb[ (threadId*interv*2) + interv + jobb]){
						temptomb[ (threadId*interv*2) + egesz] = tomb[ (threadId*interv*2) + bal];
						++bal;
					} else{
						temptomb[ (threadId*interv*2) + egesz] = tomb[ (threadId*interv*2) + interv + jobb];
						++jobb;
					}
					++egesz;
				}
			
				while(bal<interv){
					temptomb[ (threadId*interv*2) + egesz] = tomb[ (threadId*interv*2) + bal];
					++bal;
					++egesz;
				}
			
				while(jobb<interv){
					temptomb[ (threadId*interv*2) + egesz] = tomb[ (threadId*interv*2) + interv + jobb];
					++jobb;
					++egesz;
				}
			}
		
			// Ideiglenes tömb visszaírása
			for(int i=0; i<elemszam; ++i)	tomb[i] = temptomb[i];
		}
	}
	
	// A rendezett tömb kiírása (a negatív elemeket nem írja ki)
	cout << endl << endl << "Rendezve:" << endl << endl;
	for(int i=elemszam-elemsz; i<elemszam; ++i){
		cout << i-(elemszam-elemsz) << ".:" << tomb[i] << '\n';
	}
	cout << endl << endl;
	return 0;
}
